<?php

namespace Drupal\gcs\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

class GCSSettingsForm extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'gcs_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    // Form constructor.
    $form = parent::buildForm($form, $form_state);
    // Default settings.
    $config = $this->config('gcs.settings');

    $form['bucket_name'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Bucket Name'),
      '#default_value' => $config->get('gcs.bucket_name'),
      '#size' => 255,
      '#required' => TRUE,
    ];
    }

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {

  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $config = $this->config('gcs.settings');
    $config->set('gcs.bucket_name', $form_state->getValue('bucket_name'));

    $config->save();
    return parent::submitForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return [
      'gcs.settings',
    ];
  }
}